-- Initial Variable Values -- These saved variables are set to this default if there is no value --
Semi_HolyPriestBar_ActionBar = true;
Semi_HolyPriestBar_Locked = false;
Semi_HolyPriest_Grid = true;
local Semicombat;
local Semiclass = UnitClass("player");

 -- Bindings for folks to set in the Blizzard Keybindings Menu --
BINDING_HEADER_SEMIHOLYPRIESTBAR = "Semi Holy Priest Bar";
_G["BINDING_NAME_CLICK Semi_HolyPriestBarButton1:LeftButton"] = "Button 1";
_G["BINDING_NAME_CLICK Semi_HolyPriestBarButton2:LeftButton"] = "Button 2";
_G["BINDING_NAME_CLICK Semi_HolyPriestBarButton3:LeftButton"] = "Button 3";


function Semi_HolyPriest_Bar_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	self:RegisterEvent("PLAYER_TALENT_UPDATE");
	self:RegisterEvent("UNIT_ENTERING_VEHICLE");
	self:RegisterEvent("UNIT_EXITING_VEHICLE");
end
--Might have to add an update bar position for the HolyPriest bar, since i'm using slots 118-120

--On_Event--

function Semi_HolyPriest_Bar_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;
	if event == "PLAYER_ENTERING_WORLD" or (event=="ADDON_LOADED" and arg1=="Semi_Priest_Stance_Bar") then
		Semicombat = false;
		if Semiclass ~= "Priest" then
			Semi_HolyPriestBar_ActionBar = false;
			Semi_HolyPriestBar_HideBar();
		else
			Semi_Test_Current_Spec();
		end
	end
	if (event == "PLAYER_REGEN_DISABLED") then
		Semicombat = true;
	end
	if (event == "PLAYER_REGEN_ENABLED") then
		Semicombat = false;
	end	
	if ((event == "ACTIVE_TALENT_GROUP_CHANGED") or (event == "PLAYER_TALENT_UPDATE")) and (Semiclass == "Priest") then
		Semi_Test_Current_Spec();
	end
	if (event == "UNIT_ENTERING_VEHICLE") and (not Semicombat) and (Semiclass == "Priest") then
		if (arg2 == true) and (arg5 == true) then
			Semi_HolyPriestBar_HideBar();
		else
			Semi_Test_Current_Spec();
		end
	end
	if ((event == "UNIT_EXITING_VEHICLE") and (not Semicombat) and (Semiclass == "Priest")) then
		Semi_Test_Current_Spec();
	end
end

function Semi_Test_Current_Spec()
	local SemiSpec = GetSpecialization();
	local SemiSpecId = SemiSpec and select(1, GetSpecializationInfo(SemiSpec)) or "None";
	if (SemiSpecId == 257) then
		Semi_HolyPriestBar_ShowBar();
	else
		Semi_HolyPriestBar_HideBar();
	end
end

function Semi_HolyPriest_Bar_LinkFrameToDragButton()
	if (not Semicombat) then
		UIPARENT_MANAGED_FRAME_POSITIONS["Semi_HolyPriestBar"] = nil;
		if Semi_HolyPriestBar_ActionBar then 
			Semi_HolyPriestBar:Show();
			Semi_HolyPriestBar:EnableMouse("true");
			Semi_HolyPriestBar:SetScale(Semi_ChakraBar_Scale);
		end
		Semi_HolyPriestBar:ClearAllPoints();
		Semi_HolyPriestBar:SetPoint("BOTTOMLEFT", Semi_HolyPriest_BarActionBarDragButton, "BOTTOMLEFT");
		Semi_HolyPriest_GridChoice();	
	end
end

function Semi_HolyPriest_GridChoice()
	if (not Semicombat) then
		if (Semi_HolyPriest_Grid) then
			for i= 1, 3 do
				local gridbutton;
				gridbutton = getglobal("Semi_HolyPriestBarButton"..i);
				gridbutton:SetAttribute("showgrid", 1);
				ActionButton_ShowGrid(gridbutton);			
			end
		end
		if (not Semi_HolyPriest_Grid) then
			for i= 1, 3 do
				local gridbutton;
				gridbutton = getglobal("Semi_HolyPriestBarButton"..i);
				gridbutton:SetAttribute("showgrid", 0);
				ActionButton_HideGrid(gridbutton);
			end
		end
	end
end

function Semi_HolyPriestBar_HideBar()
	Semi_HolyPriestBar_Actionbar = false;
	Semi_HolyPriest_BarActionBarDragButton:SetAlpha(0);
	Semi_HolyPriest_BarActionBarDragButton:EnableMouse("false");
	Semi_HolyPriestBar:SetAlpha(0);
	Semi_HolyPriestBar:EnableMouse("false");
	for i=1, 3 do
		local temp = _G["Semi_HolyPriestBarButton"..i];
		temp:EnableMouse("false");
	end
end
	
function Semi_HolyPriestBar_ShowBar()
	Semi_HolyPriestBar_Actionbar = true;
	Semi_HolyPriestBar:EnableMouse("true");
	Semi_HolyPriestBar:SetAlpha(1);
	if (Semi_HolyPriestBar_Locked == true) then
		Semi_HolyPriestBar_LockBars();
	else
		Semi_HolyPriestBar_UnLockBars();
	end
	for i=1, 3 do
		local temp = _G["Semi_HolyPriestBarButton"..i];
		temp:EnableMouse("true");
	end	
end

function Semi_HolyPriestBar_LockBars()
    Semi_HolyPriest_BarActionBarDragButton:SetAlpha(0);
	Semi_HolyPriest_BarActionBarDragButton:EnableMouse("false");
	Semi_HolyPriestBar_Locked = true;
end        

function Semi_HolyPriestBar_UnLockBars()
    Semi_HolyPriest_BarActionBarDragButton:SetAlpha(1);
	Semi_HolyPriest_BarActionBarDragButton:EnableMouse("true");
	Semi_HolyPriestBar_Locked = false;
end